<?php

add_action('admin_menu', 'add_alc_menu');

function add_alc_menu()
{
	add_submenu_page('options-general.php', 'Link Cloaker Options', 'Link Cloaker', 8, 'affiliatelinkcloaker', 'links_management_panel');
}

function links_management_panel() {
	if (isset($_GET['edit']) &&
		isset($_GET['new'])) {
		editlink('new');
	}
	
	if (isset($_GET['edit']) &&
		!isset($_GET['new'])) {
		$linkId = (int)$_GET['edit'];
		
		editlink('edit', $linkId);
	}
	
	if (!isset($_GET['new']) &&
		!isset($_GET['edit'])) {
		show_links();
	}
}


function show_links() {
	global $wpdb, $table_prefix;
	$message = '';
	$errors = array();
	
	// url trigger updated ?
	if (isset($_POST['url_trigger']) &&
		strlen($_POST['url_trigger']) &&
		($_POST['url_trigger'] != get_option('alc_url_trigger'))) {
		update_option('alc_url_trigger', $_POST['url_trigger']);
		
		$message = 'URL trigger updated.';
	}
	
	// delete affiliate links ?
	if (isset($_POST['links'])) {
		$query = "	DELETE
					FROM
							{$table_prefix}alc_link
					WHERE
							{$table_prefix}alc_link.id in (";
		
		// sanitise and add the ids to the query
		foreach ($_POST['links'] as $link) {
			$query .= (int)$link . ',';
		}
		
		// chop the last comma off
		$query = rtrim($query, ',');
		
		// finish off the query
		$query .= ')';

		// run the query :-)
		$wpdb->query($query);
		
		// remove orphaned address records
		$query = "	DELETE
							{$table_prefix}alc_address
					FROM
							{$table_prefix}alc_address
					LEFT OUTER JOIN
							{$table_prefix}alc_link
						ON	({$table_prefix}alc_link.id = {$table_prefix}alc_address.linkId)
					WHERE
							({$table_prefix}alc_link.id IS NULL)";
		$wpdb->query($query);
		
		// finally, remove orphaned log records
		$query = "	DELETE
							{$table_prefix}alc_redirectlog
					FROM
							{$table_prefix}alc_redirectlog
					LEFT OUTER JOIN
							{$table_prefix}alc_address
						ON	({$table_prefix}alc_address.id = {$table_prefix}alc_redirectlog.addressId)
					WHERE
							({$table_prefix}alc_address.id IS NULL)";
		$wpdb->query($query);
		
		$message = 'Affiliate link(s) removed.';
	}
	
?>
<div class="wrap">
<h2>Affiliate links <a href="<?php echo get_option('siteurl') . '/wp-admin/admin.php?page=affiliatelinkcloaker&edit&new'; ?>" class="button add-new-h2">Add New</a></h2>
<?php

	if ($message) {
		echo '<div class="message updated" style="width: 97%;" id="message"><p><strong>' . $message . '</strong></p></div>';
	}
	
	if (sizeof($errors)) {
		echo '<div class="message error" style="width: 97%;" id="message"><p><strong>' . implode('<br />', $errors) . '</strong></p></div>';
	}

?>

<div style="width:100%;" class="postbox-container">
<div class="metabox-holder">
<div class="postbox" style="width:100%;">
	<h3 class="hndle">Affiliate URL Trigger</h3>
	<form method="post">
	<table style="margin:4px;" class="form-table">
	<tr>
		<td><input type="text" name="url_trigger" size="20" value="<?php  echo get_option('alc_url_trigger'); ?>"></td>
		<td><strong>URL Trigger</strong><br /><em>(Default: <strong>recommends</strong>) </em>
		</td>
		<td style="text-align:right;" width="70%" rowspan="2">
		<table>
			<tr>
			<td width="20%"></td>
			<td><p>
			Affiliate link cloaker is donationware.<br /><br />
			If you like and use this plugin, please consider a donation.<br />No amount is too small.</p>
			</td>
			<td>
			<form action="https://www.paypal.com/cgi-bin/webscr" method="post" target="_blank">
			<input type="hidden" name="cmd" value="_s-xclick">
			<input type="hidden" name="hosted_button_id" value="GEDWBWZTUJSV6">
			<input type="image" src="https://www.paypalobjects.com/en_US/GB/i/btn/btn_donateCC_LG.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online.">
			<img alt="" border="0" src="https://www.paypalobjects.com/en_GB/i/scr/pixel.gif" width="1" height="1">
			</form>
			</td>
			</tr>
		</table>
		</td>
	</tr>
	<tr>
		<td></td>
		<td><input class="button-primary" type="submit" name="go" value="Save"></td>
	</tr>
	</table>
	</form>
</div>
</div>
</div>

<form method="post" action="<?php echo get_option('siteurl') . '/wp-admin/admin.php?page=affiliatelinkcloaker'; ?>">
<table class="widefat">
	<thead>
	<tr>
	<th scope="col" id="title" class="manage-column" style="width:20px"></th>
	<th scope="col" id="title" class="manage-column" style="width:20px"></th>
	<th scope="col" id="title" class="manage-column" style="width:50px">Order</th>
	<th scope="col" id="title" class="manage-column" style="width:50px">Active</th>
	<th scope="col" id="title" class="manage-column" style="width:50px">Max Links</th>
	<th scope="col" id="author" class="manage-column" style="width:130px;">Search Text</th>
	<th scope="col" id="tags" class="manage-column" style="width:130px;">URL Suffix</th>
	<th scope="col" id="comments" class="manage-column" style="width:55px;">nofollow</th>
	<th scope="col" id="comments" class="manage-column" style="width:50px;">new<br />window</th>
	<th scope="col" id="comments" class="manage-column" style="width:60px;">addresses</th>
	<th scope="col" id="comments" class="manage-column" style="width:60px;">redirects</th>
	</tr>
	</thead>

	<tfoot>
	<tr>
	<th scope="col" class="manage-column"></th>
	<th scope="col" class="manage-column"></th>
	<th scope="col" class="manage-column">Order</th>
	<th scope="col" class="manage-column">Active</th>
	<th scope="col" class="manage-column">Max Links</th>
	<th scope="col" class="manage-column">Search Text</th>
	<th scope="col" class="manage-column">URL Suffix</th>
	<th scope="col" class="manage-column">nofollow</th>
	<th scope="col" class="manage-column">new<br />window</th>
	<th scope="col" class="manage-column">addresses</th>
	<th scope="col" class="manage-column">redirects</th>
	</tr>
	</tfoot>
<tbody>
<?php

	$url_trigger = get_option("alc_url_trigger");
	$site_url = get_option('siteurl');

	$query = "	SELECT
						alc_link.id,
						alc_link.replacementOrder,
						alc_link.flags,
						alc_link.maxReplacements,
						alc_link.searchText,
						alc_link.urlSuffix,
						IFNULL(alc_addresscount.addresses, 0)
					AS	addresses,
						(CASE
							WHEN alc_defaultaddress.id IS NULL
							THEN 0
							ELSE 1
						 END)
					AS	hasDefault,
						COUNT(alc_redirectlog.addressId)
					AS	redirects
				FROM
						{$table_prefix}alc_link
					AS	alc_link
								LEFT OUTER JOIN
						{$table_prefix}alc_address
					AS	alc_address
					ON	(alc_address.linkId = alc_link.id)
					AND	(LENGTH(alc_address.address) > 5)
				LEFT OUTER JOIN
						(SELECT
								linkId,
								COUNT(id)
							AS	addresses
						 FROM
								{$table_prefix}alc_address
							AS	alc_address
						 GROUP BY
								alc_address.linkId)
					AS	alc_addresscount
					ON	(alc_addresscount.linkId = alc_link.id)
				LEFT OUTER JOIN
						{$table_prefix}alc_address
					AS	alc_defaultaddress
					ON	(alc_defaultaddress.linkId = alc_link.id)
					AND	(alc_defaultaddress.default = 'Yes')
				LEFT OUTER JOIN
						{$table_prefix}alc_redirectlog
					AS	alc_redirectlog
					ON	(alc_redirectlog.addressId = alc_address.id)
				GROUP BY
						alc_link.id
				ORDER BY
						alc_link.replacementOrder ASC";
	$rows = $wpdb->get_results($query);
	
	foreach ($rows as $row) {
		$background = '';
		if (!$row->addresses ||
			!$row->hasDefault) {
			$background = "background: #FAEBD7;";
		}
?>
	<tr class='' valign="top">
		<th style="<?php echo $background; ?>" scope="row"><input name="links[]" value="<?php echo $row->id; ?>" type="checkbox"></th>
		<td style="text-align:left;<?php echo $background; ?>"><a title="Edit Affiliate Link" href="<?php echo 'admin.php?page=affiliatelinkcloaker&edit=' . $row->id; ?>">Edit</a></td>
		<td style="text-align:left;<?php echo $background; ?>"><?php echo $row->replacementOrder; ?></td>
		<td style="text-align:left;<?php echo $background; ?>"><?php echo (($row->flags & ALC_ACTIVE) == ALC_ACTIVE) ? 'Yes' : 'No'; ?></td>
		<td style="text-align:left;<?php echo $background; ?>"><?php echo $row->maxReplacements; ?></td>
		<td style="text-align:left;<?php echo $background; ?>"><?php echo $row->searchText; ?></td>
		<td style="text-align:left;<?php echo $background; ?>"><span title="<?php echo "$site_url/$url_trigger/" . $row->urlSuffix; ?>"><?php echo $row->urlSuffix; ?></span></td>
		<td style="text-align:left;<?php echo $background; ?>"><?php echo (($row->flags & ALC_NOFOLLOW) == ALC_NOFOLLOW) ? 'Yes' : 'No'; ?></td>
		<td style="text-align:left;<?php echo $background; ?>"><?php echo (($row->flags & ALC_OPENNEWWINDOW) == ALC_OPENNEWWINDOW) ? 'Yes' : 'No'; ?></td>
		<td style="text-align:left;<?php echo $background; ?>"><?php echo $row->addresses; ?></td>
		<td style="text-align:left;<?php echo $background; ?>"><?php echo $row->redirects; ?></td>
	</tr>
<?php
	}
?>
</tbody>
</table>

<table class="widefat post fixed" cellspacing="0">
	<thead>
	<tr>
	<td><div class="submit"><input type="submit" name="deleteselected" value="Delete Selected" /></div>
	</td>
	</tr>
</table>
</form>

</div>
<?php

}


function editlink($command = 'new', $linkId = 0) {
	global $wpdb, $table_prefix;
	$errors = array();
	$message = '';
	
	// initialise variables with default values
	$id = 0;
	$flags = 0;
	$searchText = '';
	$urlSuffix = '';
	$replacementOrder = 0;
	$maxReplacements = 0;
	$redirectType = '302';
	
	// delete an address?
	if (isset($_POST['delete_address'])) {
		$addressId = (int)$_POST['delete_address'];
		
		// delete the address
		$wpdb->query("DELETE FROM {$table_prefix}alc_address WHERE id = $addressId");
		
		// and now delete any entries in the redirect log table..
		$wpdb->query("DELETE FROM {$table_prefix}alc_redirectlog WHERE addressId = $addressId");
		
		$message = 'Address deleted.';
	}
	
	// update an address?
	if (isset($_POST['update_address'])) {
		// is this a default link ?
		if (isset($_POST['default'])) {
			// make sure that we dont end up with more than one default
			$wpdb->update($table_prefix . 'alc_address',
							array('default' => 'No'),
							array('linkId' => (int)$linkId));
		}
		
		// prepare the data
		$where = array('id' => (int)$_POST['update_address']);
		$data = array('default' => isset($_POST['default']) ? 'Yes' : 'No',
						'country' => $_POST['country'],
						'address' => $_POST['address']);
		
		// update the record
		$wpdb->update($table_prefix . 'alc_address', $data, $where, array('%s'), array('%d'));
		
		$message = 'Address updated.';
	}
	
	// create a new record ?
	if (isset($_POST['command']) &&
		$_POST['command'] == 'new') {
		// validate data....
		if (!strlen($_POST['urlsuffix'])) {
			$errors[] = 'Please provide a url suffix.';
		}
		
		// check that the url suffix is unique
		if (!isSuffixUnique($_POST['urlsuffix'])) {
			$errors[] = 'Please provide a unique suffix.';
		}
		
		// any errors ?
		if (!sizeof($errors)) {
			$flags = 0;
			
			//sanitise data
			if (isset($_POST['replacementactive'])) {
				$flags |= ALC_ACTIVE;
			}
			
			if (isset($_POST['countredirects'])) {
				$flags |= ALC_COUNTREDIRECTS;
			}
			
			if (isset($_POST['nofollow'])) {
				$flags |= ALC_NOFOLLOW;
			}
			
			if (isset($_POST['opennewwindow'])) {
				$flags |= ALC_OPENNEWWINDOW;
			}
			
			$titleText = $wpdb->escape($_POST['titletext']);
			$searchText = $wpdb->escape($_POST['searchtext']);
			$urlSuffix = $wpdb->escape($_POST['urlsuffix']);
			$replacementOrder = (int)$_POST['replacementorder'];
			$maxReplacements = (int)$_POST['maxreplacements'];
			$redirectType = $_POST['redirecttype'];
			
			$data = array(
						'flags' => $flags,
						'titleText' => $titleText,
						'searchText' => $searchText,
						'urlSuffix' => $urlSuffix,
						'replacementOrder' => $replacementOrder,
						'maxReplacements' => $maxReplacements,
						'redirectType' => $redirectType
			);
			
			// perform the insert
			$wpdb->insert($table_prefix . 'alc_link', $data);
			
			$command = 'edit';
			$linkId = $wpdb->insert_id;
			
			$message = 'New affiliate link added.';
		}
	}
	
	// update record ?
	if (isset($_POST['command']) &&
		$_POST['command'] == 'edit' &&
		$linkId) {
		// validate data....
		if (!strlen($_POST['urlsuffix'])) {
			$errors[] = 'Please provide a url suffix.';
		}
		
		// check that the url suffix is unique
		if (!isSuffixUnique($_POST['urlsuffix'], $linkId)) {
			$errors[] = 'Please provide a unique suffix.';
		}
		
		// any errors ?
		if (!sizeof($errors)) {
			$flags = 0;
			
			//sanitise data
			if (isset($_POST['replacementactive'])) {
				$flags |= ALC_ACTIVE;
			}
			
			if (isset($_POST['countredirects'])) {
				$flags |= ALC_COUNTREDIRECTS;
			}
			
			if (isset($_POST['nofollow'])) {
				$flags |= ALC_NOFOLLOW;
			}
			
			if (isset($_POST['opennewwindow'])) {
				$flags |= ALC_OPENNEWWINDOW;
			}
			
			$titleText = $wpdb->escape($_POST['titletext']);
			$searchText = $wpdb->escape($_POST['searchtext']);
			$urlSuffix = $wpdb->escape($_POST['urlsuffix']);
			$replacementOrder = (int)$_POST['replacementorder'];
			$maxReplacements = (int)$_POST['maxreplacements'];
			$redirectType = $_POST['redirecttype'];
			
			$data = array(
						'flags' => $flags,
						'titleText' => $titleText,
						'searchText' => $searchText,
						'urlSuffix' => $urlSuffix,
						'replacementOrder' => $replacementOrder,
						'maxReplacements' => $maxReplacements,
						'redirectType' => $redirectType
			);
			
			$where = array('id' => $linkId);
			
			// perform the insert
			$wpdb->update($table_prefix . 'alc_link', $data, $where);

			$message = 'Affiliate link updated.';
		}
	}
	
	if ($command == 'edit' &&
		$linkId) {
		$posturl = get_option('siteurl') . '/wp-admin/admin.php?page=affiliatelinkcloaker&edit=' . $linkId;
		
		$query = "	SELECT
							id,
							flags,
							searchText,
							urlSuffix,
							replacementOrder,
							maxReplacements,
							redirectType
					FROM
							{$table_prefix}alc_link
					WHERE
							id = $linkId";
		$row = $wpdb->get_row($query);
		
		$id = $row->id;
		$flags = $row->flags;
		$searchText = $row->searchText;
		$urlSuffix = $row->urlSuffix;
		$replacementOrder = $row->replacementOrder;
		$maxReplacements = $row->maxReplacements;
		$redirectType = $row->redirectType;
	}
	
	if ($command == 'new') {
		$posturl = get_option('siteurl') . '/wp-admin/admin.php?page=affiliatelinkcloaker&edit&new';
	}

	// has the user created a new link record?
	if ($linkId) {
		$posturl = get_option('siteurl') . '/wp-admin/admin.php?page=affiliatelinkcloaker&edit=' . $linkId;
	}
	
	// validate address stuff
	if ($linkId) {
		$query = "	SELECT
							COUNT(alc_address.id)
						AS	addresses,
							(CASE
								WHEN alc_defaultaddress.id IS NULL
								THEN 0
								ELSE 1
							 END)
						AS	defaultAddress
					FROM
							{$table_prefix}alc_link
						AS	alc_link
					LEFT OUTER JOIN
							{$table_prefix}alc_address
						AS	alc_address
						ON	(alc_address.linkId = alc_link.id)
					LEFT OUTER JOIN
							{$table_prefix}alc_address
						AS	alc_defaultaddress
						ON	(alc_defaultaddress.linkId = alc_link.id)
						AND	(alc_defaultaddress.default = 'Yes')
					WHERE
							alc_link.id = $linkId
					GROUP BY
							alc_link.id";
		$result = $wpdb->get_row($query);
		
		// have we got some addresses?
		if (!$result->addresses) {
			$errors[] = "Please add at least one address.";
		}
		
		// do we have at least one default address?
		if (!$result->defaultAddress) {
			$errors[] = "Please make one of the addresses a default";
		}
	}
	
?>
<div class="wrap">
  <form action="<?php echo $posturl; ?>" method="post">
  <input type="hidden" name="command" value="<?php echo $command; ?>" />
	<h2>Affiliate Link Options</h2>
<?php

	if ($message) {
		echo '<div class="message updated" style="width: 97%;" id="message"><p><strong>' . $message . '</strong></p></div>';
	}
	
	if (sizeof($errors)) {
		echo '<div class="message error" style="width: 97%;" id="message"><p><strong>' . implode('<br />', $errors) . '</strong></p></div>';
	}

?>
	<div class="postbox-container">
	<div class="metabox-holder">

	<div style="margin-right:100%;width:100%" class="postbox">
	<h3 class="hndle">Options</h3>
	<table width="100%" style="margin:8px;" class="form-table">
	
<tr valign="top">
	<th scope="row" style="text-align:left;"><input type="checkbox" id="replacementactive" name="replacementactive" <?php echo (($flags & ALC_ACTIVE) == ALC_ACTIVE) ? 'checked="checked"' : ''; ?> /></th>
	<td><label style="font-weight: bold;" for="replacementactive">Active</label><br />This enables the replacement of text in content with the cloaked affiliate links.</td>
</tr>
<tr valign="top">
	<th scope="row" style="text-align:left;"><input type="text" name="replacementorder" size="2" value="<?php echo (int)$replacementOrder; ?>" /></th>
	<td><strong>Replacement Order</strong><br />This is the order that the replacements are done.</td>
</tr>
<tr valign="top">
	<th scope="row" style="text-align:left;"><input type="text" name="maxreplacements" size="2" value="<?php echo (int)$maxReplacements; ?>" /></th>
	<td><strong>Max Replacements</strong><br />Maximum number of replacements per post. Setting this to zero will cause all keyword occurances to be replaced.</td>
</tr>
<tr valign="top"> 
	<th scope="row" style="text-align:left;"><input type="text" name="searchtext" size="20" value="<?php echo htmlentities($searchText); ?>" /></th>
	<td><strong>Search Text</strong><br />This is the text that is searched for in the article content.</td>
</tr>
<tr valign="top">
	<th scope="row" style="text-align:left;"><input type="text" name="urlsuffix" size="20" value="<?php echo htmlentities($urlSuffix); ?>" /></td>
	<td><strong>Cloaked URL suffix</strong><br />This text will be placed at the end of the cloaked url like this: <?php echo get_option('siteurl'); ?>/recommends/<strong>cloaked_url_suffix</strong>. This suffix must be unique.</td>
</tr>
<tr valign="top">
	<th scope="row" style="text-align:left;"><input type="checkbox" id="countredirects" name="countredirects" <?php echo (($flags & ALC_COUNTREDIRECTS) == ALC_COUNTREDIRECTS) ? 'checked="checked"' : ''; ?> /></td>
	<td><label style="font-weight: bold;" for="countredirects">Count Redirects</label><br />This enables the counting of redirects that are performed.</td>
</tr>
<tr valign="top">
	<th scope="row" style="text-align:left;"><input type="checkbox" id="nofollow" name="nofollow" <?php echo (($flags & ALC_NOFOLLOW) == ALC_NOFOLLOW) ? 'checked="checked"' : ''; ?> /></td>
	<td><label style="font-weight: bold;" for="nofollow">Nofollow Link</label><br />This puts a no follow tag on the link.</td>
</tr>
<tr valign="top">
	<th scope="row" style="text-align:left;"><input type="checkbox" id="opennewwindow" name="opennewwindow" <?php echo (($flags & ALC_OPENNEWWINDOW) == ALC_OPENNEWWINDOW) ? 'checked="checked"' : ''; ?> /></td>
	<td><label style="font-weight: bold;" for="opennewwindow">Open link in new window</label><br />This causes the link to open in a new browser window.</td>
</tr>
<tr valign="top">
	<th scope="row" style="text-align:left;"><?php redirectTypeCombo('redirecttype', $redirectType); ?></td>
	<td><label style="font-weight: bold;" for="redirecttype">Redirect type</label><br />These are http status codes - documentation for them can be found <a target="_blank" href="http://en.wikipedia.org/wiki/URL_redirection">here</a>. This will default to a 302 redirect. If this is set to a 301 redirect, most modern browsers will cache the redirect and any changes to the addresses below will not show for a specific user if they have already following the link.</td>
</tr>
<tr valign="top">
	<th scope="row"></td>
	<td><input class="button-primary" name="go" value="Save" type="submit"><br /><br /></td>
</tr>

	</table>
	</div>

</div>
</div>
</form>

<?php
	if ($linkId) {
		addAffiliateLinks($linkId);
	}
?>

</div>

<?php	
}


function addAffiliateLinks($linkId) {
	global $wpdb, $table_prefix;
	
	$posturl = get_option('siteurl') . "/wp-admin/admin.php?page=affiliatelinkcloaker&edit=$linkId#links";

?>
<h2>Addresses <a href="<?php echo get_option('siteurl') . "/wp-admin/admin.php?page=affiliatelinkcloaker&edit=$linkId&newaffiliatelink#links"; ?>" class="button add-new-h2">Add New</a></h2>
<?php

	// add a new affiliate link ?
	if (isset($_GET['newaffiliatelink'])) {
		// insert a blank record...
		$data = array('linkId' => $linkId);
		
		$wpdb->insert($table_prefix . 'alc_address', $data, '%d');
	}
?>
<table id="links" class="widefat">
	<thead>
	<tr>
	<th scope="col" id="title" class="manage-column" style="width:10px">Address</th>
	<th scope="col" id="title" class="manage-column" style="width:10px">Default</th>
	<th scope="col" id="title" class="manage-column" style="width:50px">Country</th>
	<th scope="col" id="title" class="manage-column" style="width:10px">Redirects</th>
	<th scope="col" id="title" class="manage-column" style="width:20px"></th>
	<th scope="col" id="title" class="manage-column" style="width:20px"></th>
	</tr>
	</thead>

	<tfoot>
	<tr>
	<th scope="col" class="manage-column">Affiliate Link</th>
	<th scope="col" class="manage-column">Default</th>
	<th scope="col" class="manage-column">Country</th>
	<th scope="col" class="manage-column">Redirects</th>
	<th scope="col" class="manage-column"></th>
	<th scope="col" class="manage-column"></th>
	</tr>
	</tfoot>
<tbody>
<?php
	$query = "	SELECT
						alc_address.id,
						alc_address.address,
						alc_address.country,
						alc_address.default,
						COUNT(alc_redirectlog.addressId)
					AS	redirects
				FROM
						{$table_prefix}alc_address
					AS	alc_address
				LEFT OUTER JOIN
						{$table_prefix}alc_redirectlog
					AS	alc_redirectlog
					ON	(alc_redirectlog.addressId = alc_address.id)
				WHERE
						(alc_address.linkId = $linkId)
				GROUP BY
						alc_address.id";
	$rows = $wpdb->get_results($query);
	
	$forceDefault = (sizeof($rows) == 1);
	
	foreach ($rows as $row) {
?>
	<tr class='' valign="top">
		<form action="<?php echo $posturl; ?>" method="post">
		<input type="hidden" name="update_address" value="<?php echo $row->id; ?>" />
		<td style="text-align:left;"><input type="text" size="70" name="address" value="<?php echo $row->address; ?>" /></td>
		<td style="text-align:left;">
		<input type="checkbox" name="default" <?php echo ($row->default == 'Yes' || $forceDefault) ? 'checked="checked"' : ''; ?> />
		</td>
		<td><?php countrycombo('country', $row->country); ?></td>
		<td><?php echo $row->redirects; ?></td>
		<td><input class="button-primary" type="submit" value="Update" /></td>
		</form>
		<form action="<?php echo $posturl; ?>" method="post">
		<td>
			<input type="hidden" name="delete_address" value="<?php echo $row->id; ?>" />
			<input class="button-primary" type="submit" value="Delete" onclick="return confirm('Press OK to delete address.')" />
		</td>
		</form>
	</tr>
<?php
	}
?>
</tbody>
</table>
<?php
}


function isSuffixUnique($suffix, $id = 0) {
	global $wpdb, $table_prefix;
	
	// no suffix, dont bother doing anything
	if (!$suffix) {
		return false;
	}
	
	// prepare the data
	$escapedSuffix = $wpdb->escape($suffix);
	$id = (int)$id;
	
	$query = "	SELECT
						COUNT(id)
					AS	suffixCount
				FROM
						{$table_prefix}alc_link
				WHERE
						(urlSuffix = '$escapedSuffix')
					AND	(id <> $id)";
	
	$row = $wpdb->get_row($query);
	
	return ($row->suffixCount == 0) ? true : false;
}


function squashText($text, $maxLength, $seperator, $seperatorPos) {
	$textLen = strlen($text);
	
	// do we need to process the text ?
	if ($textLen < $maxLength) {
		return $text;
	}
	
	$seperatorLen = strlen($seperator);
	
	return substr($text, 0, $textLen - $seperatorLen - $seperatorPos) .
			$seperator . substr($text, $textLen - $seperatorPos);


}

function redirectTypeCombo($name, $default = '') {
	$types = array(0 => '300', '301', '302', '303', '307');
	
	echo "<select name=\"$name\">";
		
	foreach ($types as $type) {
		echo '<option style="padding-right:10px;"';
		
		// a default?
		echo ($type == $default) ? ' selected' : '';
		
		echo ">$type</option>\n";
	}
	
	echo '</select>';

}

function countrycombo($name, $default = '') {
	global $wpdb, $table_prefix;
	
	/* if the region detect plugin is not installed
	 * just display a text box
	 */
	 
	if (!is_plugin_active('regiondetect/regiondetect.php')) {
		echo '<input type="text" size="2" name="country" value="' . $default . '" />';
		
		return;
	}
	
	$query = "	SELECT
						countryCode,
						countryName
				FROM
						{$table_prefix}rd_countrynames
				ORDER BY
						countryName ASC";
	$rows = $wpdb->get_results($query);
	
	echo "<select name=\"$name\">";
		
	foreach ($rows as $row) {
		echo '<option value="' . $row->countryCode . '"';
		
		// a default?
		echo ($row->countryCode == $default) ? ' selected' : '';
		
		// the text
		echo '>' .  $row->countryName . "</option>\n";
	}
	
	echo '</select>';
}

?>